var platform = require("os").platform;
var install_process = require("child_process");
var path = require('path');

function exManPath() {
    switch (platform()) {
        case "darwin":
            return "ExManCmd/osx/Contents/MacOS/ExManCmd";
            break;
        case "win32", "win64":
            return "ExManCmd/win/ExManCmd.exe";
            break;
       default:
            return "ExManCmd/win/ExManCmd.exe";
    }
    return null;
}

var prefix = (platform() == "darwin") ? "--" : "/"
    
function uninstallExtension(dir)  {
    
 
    return promise = new Promise(function (resolve, reject) {
        
        var spawn = install_process.spawn(path.join(dir, exManPath()), [prefix + "remove", "com.MarcusEckertAS.Squall"]);
        spawn.stdout.on('data', function (data) {
            
            resolve(null);
        });
        spawn.stderr.on('data', function (data) {
            
            reject("Oops, couldn't remove that...");
        });
        spawn.on('exit', function (code) {
            
            if (code == 0) { resolve(); }
            else {
                reject("Something went wrong.");
            }
        });
    });
};
    
    
function checkInstalledVersion(dir) {
    return promise = new Promise(function (resolve, reject) {
        var spawn = install_process.spawn(path.join(dir, exManPath()), [prefix + "list", "all"]);
        var d = null;
        spawn.stdout.on('data', function (data) {
            d = d ? d + data.toString() : data.toString();
       
           
        });
        spawn.stderr.on('data', function (data) {
            reject(); 
        });
        
        var evalF = function(){
           var result = /(com.MarcusEckertAS.Squall)[\s]*([\d\.]*)\n/.exec(d.toString());
            if (result && result[2]) {
                resolve(result[2]);
            } else {
                reject();
            }
        };
        
        spawn.on('exit', function (code) {
            setTimeout(evalF, 500);            
        });
        
    });
};


function installAtPath(pathD, dir) {


    return promise = new Promise(function (resolve, reject) {

        var spawn = install_process.spawn(path.join(dir, exManPath()), [prefix + "install", pathD]);

        spawn.stdout.on('data', function (data) {
            console.log('stdout: ' + data.toString());
            var c = /(\d+)/.exec(data.toString());
            var code = c && c[1] ? parseInt(c)*-1 : null;
            console.log("pass Code", code);
             reject(code);
        });

        spawn.stderr.on('data', function (data) {
            console.log('stderr: ' + data.toString());
            var logbits = /(\d{4}-\d{2}-\d{2}) (\d{2}:\d{2}:\d{2}) : ([A-Z]+)\s+(.*)/.exec(data.toString());
            var date = logbits[1];
            var time = logbits[2];
            var level = logbits[3];
            var message = logbits[4];
            if (level === 'ERROR') { reject(message); }
        });

        // code 0 => success
        spawn.on('exit', function (code) {
            if (code == 0) { resolve() }
        });

    });



};
